from testUtils import *
from test_flask_en_cours import *


# def test_creer_demande_publication_acceptee(client):
#     # 1. login créée un contenu
#     login = creerUtilisateurRandom(client)
#     id = creerContenuRandom(client, login)
#
#     # 2. login2 le met dans ses tiers
#     loginDeux = creerUtilisateurRandom(client)
#     data = {"id_tiers": json.dumps(id), "auteur": loginDeux, "version": 1}
#     rv = client.patch("/contenus/ajouterTiers", json=data, headers=get_headers(client))
#     assert rv.status_code == 201
#
#     # 3. login2 modifie son contenu tiers
#     data = {"auteur": loginDeux, "id_contenu": json.dumps(id), "provenance": "perso", "version": 1}
#     # création d'un contenu en_cours
#     rv = client.post("/en_cours/newEnCours", json=data, headers=get_headers(client))
#     assert rv.status_code == 201
#     id_en_cours = json.loads(rv.data)["_id"]
#
#     # 3. et y ajoute un nouveau titre
#     data = {"titre": "nouveauTitreContenu", "id_contenu_en_cours": json.dumps(id_en_cours)}
#     rv = client.patch("/en_cours/changerTitre", json=data, headers=get_headers(client))
#     assert rv.status_code == 201
#
#     # loginDeux fait une demande de publication sur le contenu en cours qui vient d'être créé
#     data = {"id_contenu": json.dumps(id), "id_contenu_en_cours": json.dumps(id_en_cours), "auteur_en_cours": loginDeux,
#             "version": 1}
#     rv = client.post("/demande_pub/demandePublication", json=data, headers=get_headers(client))
#     assert rv.status_code == 201
#     id_publication = json.loads(rv.data)["_id"]
#
#     # On controle les demandes de publication recues de login
#     rv = client.get("/demande_pub/demandePublication/" + login + "/False", headers=get_headers(client))
#     assert rv.status_code == 200
#     assert len(json.loads(rv.data)) == 1
#
#     # On contrôle les demandes de publication proposées de loginDeux
#     rv = client.get("/demande_pub/demandePublication/" + loginDeux + "/True", headers=get_headers(client))
#     assert rv.status_code == 200
#     assert len(json.loads(rv.data)) == 1
#
#     # Charles accepte la demande de publication
#     data = {"id_publication": json.dumps(id_publication), "reponse": 'o', "auteur": loginDeux}
#     rv = client.patch("/contenus/gererDemandePub", json=data, headers=get_headers(client))
#     assert rv.status_code == 200
#
#     # On supprime le tiers chez LoginDeux
#     rv = client.delete("/contenus/deleteTiers?id_tiers=" + json.dumps(id) + "&auteur=" + loginDeux + "&note=-",
#                        headers=get_headers(client))
#     assert rv.status_code == 200
#
#     supprimer_demande_publication(client, id, id_publication)
#     supprimerUtilisateur(client, login)
#     supprimerUtilisateur(client, loginDeux)


def test_creer_demande_publication_refusee_creation_en_cours_refuse(client):
    # 1. login créée un contenu
    login = creerUtilisateurRandom(client)
    id = creerContenuRandom(client, login)

    print("id test_creer_demande_publication_refusee_creation_en_cours_refuse : ", id)

    # 2. login2 le met dans ses tiers
    loginDeux = creerUtilisateurRandom(client)
    data = {"id_tiers": json.dumps(id), "auteur": loginDeux, "version": 1}
    rv = client.patch("/contenus/ajouterTiers", json=data, headers=get_headers(client))
    assert rv.status_code == 201

    # 3. login2 modifie son contenu tiers
    data = {"auteur": loginDeux, "id_contenu": json.dumps(id), "provenance": "perso", "version": 1}
    # création d'un contenu en_cours
    rv = client.post("/en_cours/newEnCours", json=data, headers=get_headers(client))
    assert rv.status_code == 201
    id_en_cours = json.loads(rv.data)["_id"]

    # 3. et y ajoute un nouveau titre
    data = {"titre": "nouveauTitreContenu", "id_contenu_en_cours": json.dumps(id_en_cours)}
    rv = client.patch("/en_cours/changerTitre", json=data, headers=get_headers(client))
    assert rv.status_code == 201

    # loginDeux fait une demande de publication sur le contenu en cours qui vient d'être créé
    data = {"id_contenu": json.dumps(id), "id_contenu_en_cours": json.dumps(id_en_cours), "auteur_en_cours": loginDeux,
            "version": 1}
    rv = client.post("/demande_pub/demandePublication", json=data, headers=get_headers(client))
    assert rv.status_code == 201
    id_publication = json.loads(rv.data)["_id"]

    # On controle les demandes de publication recues de login
    rv = client.get("/demande_pub/demandePublication/" + login + "/False", headers=get_headers(client))
    assert rv.status_code == 200
    assert len(json.loads(rv.data)) == 1

    # On contrôle les demandes de publication proposées de loginDeux
    rv = client.get("/demande_pub/demandePublication/" + loginDeux + "/True", headers=get_headers(client))
    assert rv.status_code == 200
    assert len(json.loads(rv.data)) == 1

    # Charles refuse la demande de publication
    data = {"id_publication": json.dumps(id_publication), "reponse": 'n', "auteur": login}
    rv = client.patch("/contenus/gererDemandePub", json=data, headers=get_headers(client))
    assert rv.status_code == 200

    # Jacques créée un en-cours refuse
    data = {"id_contenu_en_cours": json.dumps(id_en_cours)}
    rv = client.patch("/en_cours/newEnCoursRefuse", json=data, headers=get_headers(client))
    assert rv.status_code == 201

    rv = client.delete("/en_cours/supprimerEnCoursParId/" + json.dumps(id_en_cours), headers=get_headers(client))
    assert rv.status_code == 200

    # On supprime le tiers chez LoginDeux
    rv = client.delete("/contenus/deleteTiers?id_tiers=" + json.dumps(id) + "&auteur=" + loginDeux + "&note=-",
                       headers=get_headers(client))
    assert rv.status_code == 200

    supprimer_demande_publication(client, id, id_publication)

    supprimerUtilisateur(client, login)
    supprimerUtilisateur(client, loginDeux)


def test_creer_demande_publication_refusee_creation_nouveau_contenu(client):
    # 1. login créée un contenu
    login = creerUtilisateurRandom(client)
    id = creerContenuRandom(client, login)

    print("id test_creer_demande_publication_refusee_creation_nouveau_contenu : ", id)

    # 2. login2 le met dans ses tiers
    loginDeux = creerUtilisateurRandom(client)
    data = {"id_tiers": json.dumps(id), "auteur": loginDeux, "version": 1}
    rv = client.patch("/contenus/ajouterTiers", json=data, headers=get_headers(client))
    assert rv.status_code == 201

    # 3. login2 modifie son contenu tiers
    data = {"auteur": loginDeux, "id_contenu": json.dumps(id), "provenance": "perso", "version": 1}
    # création d'un contenu en_cours
    rv = client.post("/en_cours/newEnCours", json=data, headers=get_headers(client))
    assert rv.status_code == 201
    id_en_cours = json.loads(rv.data)["_id"]

    # 3. et y ajoute un nouveau titre
    data = {"titre": "nouveauTitreContenu", "id_contenu_en_cours": json.dumps(id_en_cours)}
    rv = client.patch("/en_cours/changerTitre", json=data, headers=get_headers(client))
    assert rv.status_code == 201

    # loginDeux fait une demande de publication sur le contenu en cours qui vient d'être créé
    data = {"id_contenu": json.dumps(id), "id_contenu_en_cours": json.dumps(id_en_cours), "auteur_en_cours": loginDeux,
            "version": 1}
    rv = client.post("/demande_pub/demandePublication", json=data, headers=get_headers(client))
    assert rv.status_code == 201
    id_publication = json.loads(rv.data)["_id"]

    # On controle les demandes de publication recues de login
    rv = client.get("/demande_pub/demandePublication/" + login + "/False", headers=get_headers(client))
    assert rv.status_code == 200
    assert len(json.loads(rv.data)) == 1

    # On contrôle les demandes de publication proposées de loginDeux
    rv = client.get("/demande_pub/demandePublication/" + loginDeux + "/True", headers=get_headers(client))
    assert rv.status_code == 200
    assert len(json.loads(rv.data)) == 1

    # Charles refuse la demande de publication
    data = {"id_publication": json.dumps(id_publication), "reponse": 'n', "auteur": login}
    rv = client.patch("/contenus/gererDemandePub", json=data, headers=get_headers(client))
    assert rv.status_code == 200

    # Du coup loginDeux doit avoir un contenu dans son panier
    rv = client.get("/contenus/getContenuPanier/" + loginDeux + "?perso=True&tiers=True&en_cours=True",
                    headers=get_headers(client))
    assert rv.status_code == 200
    nombrePanier = len(json.loads(rv.data))

    # Jacques créée un nouveau contenu
    data = {"id_demande_pub": json.dumps(id_publication), "auteur": loginDeux}
    rv = client.post("/contenus/newContenu", json=data, headers=get_headers(client))
    assert rv.status_code == 201

    id_nvo_perso = json.loads(rv.data)["_id"]

    # Du coup loginDeux doit avoir un contenu de plus dans son panier
    rv = client.get("/contenus/getContenuPanier/" + loginDeux + "?perso=True&tiers=True&en_cours=True",
                    headers=get_headers(client))
    assert rv.status_code == 200
    assert len(json.loads(rv.data)) == nombrePanier + 1

    # rv = client.delete("/en_cours/supprimerEnCoursParId/" + json.dumps(id_en_cours), headers=get_headers(client))
    # assert rv.status_code == 200

    # On supprime le tiers chez LoginDeux
    rv = client.delete("/contenus/deleteTiers?id_tiers=" + json.dumps(id) + "&auteur=" + loginDeux + "&note=-",
                       headers=get_headers(client))
    assert rv.status_code == 200

    rv = client.delete("/contenus/deletePerso/" + json.dumps(id_nvo_perso), headers=get_headers(client))
    assert rv.status_code == 200

    supprimer_demande_publication(client, id, id_publication)

    supprimerUtilisateur(client, login)
    supprimerUtilisateur(client, loginDeux)


def supprimer_demande_publication(client, id, id_publication):
    rv = client.delete("/contenus/deletePerso/" + json.dumps(id), headers=get_headers(client))
    assert rv.status_code == 200

    rv = client.delete("/demande_pub/demandePublication/" + json.dumps(id_publication), headers=get_headers(client))
    assert rv.status_code == 200
